#include <zephyr/sys/printk.h>
#include <string.h>
#include <zephyr/device.h>
#include <zephyr/drivers/flash.h>
#include <zephyr/storage/flash_map.h>

#include "xip_code.h"



void xip_test_print(){
  printk("Hello from XIP\n");
}

void xip_test_write_ext_flash(){
  static uint8_t write_buf[4096];
  static uint8_t read_buf[4096];
  static uint8_t zero_buf[4096];

	for (int i = 0; i < sizeof(write_buf); i++) {
		write_buf[i] = i;
		zero_buf[i] = 0xff;
	}

  const struct device *flash_device = FIXED_PARTITION_DEVICE(TEST_PARTITION);
  const int flash_offset = FIXED_PARTITION_OFFSET(TEST_PARTITION);
  const size_t flash_size = FIXED_PARTITION_SIZE(TEST_PARTITION);

  size_t offset = 0;

	if (!device_is_ready(flash_device)) {
		printk("Flash device %s is not ready\n", flash_device->name);
		return;
	}
  while(1){
    int rc;


    if (offset >= flash_size) {
      return;
    }

    /* rc = flash_erase(flash_device, flash_offset + offset, sizeof(write_buf)); */
    /* __ASSERT(rc == 0, "ERASE failed at offset %zu", offset); */
    /*  */
    /* rc = flash_read(flash_device, flash_offset + offset, read_buf, sizeof(read_buf)); */
    /*  */
    /* __ASSERT(rc == 0, "READ ERASE failed at offset %zu", offset); */
    /* __ASSERT(memcmp(read_buf, zero_buf, sizeof(read_buf)) == 0, "VERIFY ERASE failed at offset %zu", offset); */

    rc = flash_write(flash_device, flash_offset + offset, write_buf, sizeof(write_buf));
    __ASSERT(rc == 0, "WRITE failed at offset %zu", offset);
    rc = flash_read(flash_device, flash_offset + offset, read_buf, sizeof(read_buf));
    __ASSERT(memcmp(read_buf, write_buf, sizeof(write_buf)) == 0, "READ failed at offset %zu", offset);
    __ASSERT(memcmp(read_buf, write_buf, sizeof(write_buf)) == 0, "VERIFY failed at offset %zu", offset);
    offset += sizeof(write_buf);
  }
}
